var eid_ee = {};
var console;

eid_ee.onload = function() {  
    this.initialized = true;
    this.strings = document.getElementById("eid_ee-strings");
    
    document
        .getElementById("contentAreaContextMenu")
        .addEventListener("popupshowing", function (e) {
            eid_ee.onpopup(e);
        }, false);
    
    console = Firebug.Console;
}

eid_ee.oncommand = function(e) {
    var url;
    var browser = document.getElementById("content"); // instance of tabbrowser
    
    if (gContextMenu.onLink)   
        url = gContextMenu.linkURL;
    else
        url = browser.selectedBrowser.contentWindow.location.href;
    eid_ee.shorten(url);
}

eid_ee.onpopup = function(e) {
    var labelstr;
    var url;
    var hide = false;
    
    // Depending on the context menu that has appeared, decide
    // whether we need to display the eid.ee entry
    
    if (gContextMenu.onLink) {
        labelstr = "link_label";        
        if (!RegExp("^(http|ftp)").test(gContextMenu.linkProtocol))
            hide = true;
    }
    else {
        labelstr = "page_label";        
        if (document.getElementById("context-savepage").getAttribute("hidden") == "true")
            hide = true;
    }
    
    if (hide) {
        document.getElementById("context-eid_ee").setAttribute("hidden", "true");
        return;
    }
    
    labelstr = this.strings.getString(labelstr);
    document.getElementById("context-eid_ee").setAttribute("label", labelstr);
    document.getElementById("context-eid_ee").setAttribute("hidden", "false");
};

eid_ee.shorten = function(url) {
    const Cc = Components.classes;
    const Ci = Components.interfaces;
    var browser = document.getElementById("content");
    var datastr = "action=generate&url=" + encodeURIComponent(url);
    var sstream = Cc["@mozilla.org/io/string-input-stream;1"]
        .createInstance(Ci.nsIStringInputStream);
    var postdata;
    
    // Prepare POST data
    
    sstream.data = datastr;    
    postdata = Cc["@mozilla.org/network/mime-input-stream;1"]
        .createInstance(Ci.nsIMIMEInputStream);
    postdata.addHeader("Content-Type", "application/x-www-form-urlencoded");
    postdata.addContentLength = true;
    postdata.setData(sstream);
    
    // Open eid.ee in new tab
    
    browser.addTab("http://eid.ee", {postData: postdata});
}

window.addEventListener("load", function() {
    eid_ee.onload();    
}, false);
